/*----------------------------------------------------------------------------
/ ėp񏈗										2005 (C)LogicPack
/	05.04										000		M.Yamada
/		first release(M-802)
/---------------------------------------------------------------------------*/
#include <string.h>
#include <ctype.h>
#include "mstring.h"

/*-----------------------------------------------
/ *STATIC
/----------------------------------------------*/
static const char hex_char[] = "0123456789ABCDEF";

/*-------------------------------------------------------------------
/ 32bitf[^16iɕϊ
/------------------------------------------------------------------*/
#if 0
char *dword2str(dword num, char *buf)
{
	dword_t dtmp;
	dtmp.data = num;
	*(buf + 0) = hex_char[(dtmp.words.hi.bytes.hi >> 4) & 0xf];
	*(buf + 1) = hex_char[dtmp.words.hi.bytes.hi & 0xf];
	*(buf + 2) = hex_char[(dtmp.words.hi.bytes.lo >> 4) & 0xf];
	*(buf + 3) = hex_char[dtmp.words.hi.bytes.lo & 0xf];
	*(buf + 4) = hex_char[(dtmp.words.lo.bytes.hi >> 4) & 0xf];
	*(buf + 5) = hex_char[dtmp.words.lo.bytes.hi & 0xf];
	*(buf + 6) = hex_char[(dtmp.words.lo.bytes.lo >> 4) & 0xf];
	*(buf + 7) = hex_char[dtmp.words.lo.bytes.lo & 0xf];
	*(buf + 8) = '\0';
	return buf;
}
#endif
/*-------------------------------------------------------------------
/ 16bitf[^16iɕϊ
/------------------------------------------------------------------*/
#if 0
char *word2str(word num, char *buf)
{
	word_t wtmp;
	wtmp.data = num;
	*(buf + 0) = hex_char[(wtmp.bytes.hi >> 4) & 0xf];
	*(buf + 1) = hex_char[wtmp.bytes.hi & 0xf];
	*(buf + 2) = hex_char[(wtmp.bytes.lo >> 4) & 0xf];
	*(buf + 3) = hex_char[wtmp.bytes.lo & 0xf];
	*(buf + 4) = '\0';
	return buf;
}
#endif
/*-------------------------------------------------------------------
/ 8bitf[^16iɕϊ
/------------------------------------------------------------------*/
#if 0
char *byte2str(byte num, char *buf)
{
	*(buf + 0) = hex_char[(num>>4)&0xf];
	*(buf + 1) = hex_char[num&0xf];
	*(buf + 2) = '\0';
	return buf;
}
#endif
/*-------------------------------------------------------------------
/ l->10iϊ
/------------------------------------------------------------------*/
#if 0
char *utoa(word num, char *buf)
{
	char *p;
	word n;
	int	 i;

	p = buf;
	for( n = 10000; n > 0; n /= 10 ){
		i = num / n;
		num %= n;
		if( p == buf && i == 0 ){
		}else{
			*p++ = i + '0';
		}
	}
	if( p == buf ){ *p++ = '0'; }	/* num = 0O */
	*p = '\0';
	return buf;
}
#endif
/*-------------------------------------------------------------------
/ DEC
/------------------------------------------------------------------*/
dword str2dec(const char *str)
{
	dword data = 0;
	while( *str != '\0' ){
		if( *str >= '0' && *str <= '9' ){
			data *= 10;
			data += (*str - '0');
		}else{								/* error */
			data = 0;
			break;
		}
		str++;
	}
	return data;
}

/*-------------------------------------------------------------------
/ HEX
/------------------------------------------------------------------*/
dword str2hex(const char *str)
{
	dword data = 0;
	while( *str != '\0' ){
		if( *str >= '0' && *str <= '9' ){
			data <<= 4;
			data += (*str - '0');
		}else if( *str >= 'a' && *str <= 'f' ){
			data <<= 4;
			data += ((*str - 'a') + 0x0a);
		}else if( *str >= 'A' && *str <= 'F' ){
			data <<= 4;
			data += ((*str - 'A') + 0x0a);
		}else{								/* error */
			data = 0;
			break;
		}
		str++;
	}
	return data;
}
/*-------------------------------------------------------------------
/ Skip Space
/------------------------------------------------------------------*/
const char *skip_space(const char *str)
{
	while(*str != '\0'){
		if( !isspace(*str) ){ break; }
		str++;
	}
	return str;
}

/*-------------------------------------------------------------------
/ 񒊏o
/------------------------------------------------------------------*/
const char *extract_str(const char *src, char *dst, int max)
{
	while( *src != '\0' && max > 0 ){
		if( isspace(*src) ){ break; }
		*dst++ = *src++;
		max--;
	}
	*dst = '\0';
	while( *src != '\0' ){
		if( isspace(*src) ){ break; }
		src++;
	}
	return src;
}
